// Template ID, Device Name and Auth Token are provided by the Blynk.Cloud
// See the Device Info tab, or Template settings
#define BLYNK_TEMPLATE_ID "TMPLGxfnBGC4"
#define BLYNK_DEVICE_NAME "My CPX"
#define BLYNK_AUTH_TOKEN  "gaDGM0EeFaPuKLHSbQEkOO6_PbcRoUa_"

// Comment this out to disable prints and save space
#define BLYNK_PRINT SerialUSB

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <Adafruit_CircuitPlayground.h>
#include <Proximity.h>
Proximity prox;
byte touchPin;

char auth[] = BLYNK_AUTH_TOKEN;

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "AndroidAP";
char pass[] = "elad951951";

// Hardware Serial on Mega, Leonardo, Micro...
#define EspSerial Serial1

// or Software Serial on Uno, Nano...
//#include <SoftwareSerial.h>
//SoftwareSerial EspSerial(2, 3); // RX, TX

// Your ESP8266 baud rate:
#define ESP8266_BAUD 115200

ESP8266 wifi(&EspSerial);

BlynkTimer timer;

// This function sends Arduino's up time every second to Virtual Pin (5).
// In the app, Widget's reading frequency should be set to PUSH. This means
// that you define how often to send data to Blynk App.
void myTimerEvent()
{
  // You can send any value at any time.
  // Please don't send more that 10 values per second.
  Blynk.virtualWrite(V7, touchPin);
  Blynk.virtualWrite(V4, String(prox.lastDist()));

  // Red laert animation when more water is needed
   if (touchPin<30) {
    for (int j = 0; j < 3; j++) {
      for (int i = 0; i < 12; i++) {
        CircuitPlayground.setPixelColor(i , 255,   0,   0);
        CircuitPlayground.setPixelColor(i - 2 , 0,   0,   0);
        delay(30);
      }
    }
  }
}

BLYNK_WRITE(V2){
  double pinValue = param.asDouble();
  Serial.println(String("got: ") + pinValue);
}
 
void setup()
{
  Serial.begin(9600);
  CircuitPlayground.begin();

   while (!Serial);
  Serial.begin(19200);
  //Change this number for your sensitivity, make higher if always says "Close to object", make lower if you can't get it to say "Close to object".
  prox.begin(80);
  
  // Debug console
  SerialUSB.begin(115200);

  // Set ESP8266 baud rate
  EspSerial.begin(ESP8266_BAUD);
  delay(10);
 
  Blynk.begin(auth, wifi, ssid, pass);
  // You can also specify server:
  //Blynk.begin(auth, wifi, ssid, pass, "blynk.cloud", 80);
  //Blynk.begin(auth, wifi, ssid, pass, IPAddress(192,168,1,100), 8080);

  // Setup a function to be called every second
  timer.setInterval(1000L, myTimerEvent);
}

void loop()
{
  touchPin = CircuitPlayground.readCap(A1);
 
 // noise alert When insects/birds attack the plant
  if (prox.close()) {
    CircuitPlayground.playTone(300, 100, false);
    CircuitPlayground.playTone(300, 100, false);
    CircuitPlayground.playTone(300, 100, false);
    delay(45);
    CircuitPlayground.playTone(300, 100, false);
    CircuitPlayground.playTone(300, 100, false);
    CircuitPlayground.playTone(300, 100, false);
    delay(45);
    CircuitPlayground.playTone(300, 100, false);
    CircuitPlayground.playTone(300, 100, false);
    CircuitPlayground.playTone(300, 100, false);
  } 
 
  Blynk.run();
  timer.run(); // Initiates BlynkTimer
}
